diff --git a/app/javascript/jstoolbar.js b/app/javascript/jstoolbar.js
new file mode 100644
index 000000000..e344d793f
--- /dev/null
+++ b/app/javascript/jstoolbar.js
@@ -0,0 +1,550 @@
+/**
+ * This file is part of DotClear.
+ * Copyright (c) 2005 Nicolas Martin & Olivier Meunier and contributors. All rights reserved.
+ * This code is released under the GNU General Public License.
+ *
+ * Modified by JP LANG for multiple text formatting
+ */
+import { isMac } from 'helper'
+
+export default class jsToolBar {
+  static lastJstPreviewed = null;
+
+  constructor(controller, formatter) {
+    if (!controller) { return; }
+
+    this.textarea     = controller.editorTarget;
+    this.toolbarBlock = controller.element
+    this.editor       = controller.mainTarget;
+    this.preview      = controller.previewTarget;
+    this.tabsBlock    = controller.tabsTarget;
+    this.formatter    = formatter;
+
+    const preview_id = `preview_${this.textarea.getAttribute('id')}`
+    this.preview.setAttribute('id', preview_id)
+
+    this.editTab = controller.edittabTarget;
+    jsTabname(this.editTab, 'Edit')
+
+    this.previewTab = controller.previewtabTarget;
+    jsTabname(this.previewTab, 'Preview')
+
+    this.toolbar = controller.elementsTarget;
+
+    // Dragable resizing
+    if (typeof this.editor !== 'undefined' && this.editor.addEventListener && navigator.appVersion.match(/\bMSIE\b/))
+    {
+      this.handle = document.createElement('div');
+      this.handle.className = 'jstHandle';
+      this.handle.addEventListener('mousedown',(event) => { this.resizeDragStart(event); },false);
+      this.editor.parentNode.insertBefore(this.handle,this.editor.nextSibling);
+    }
+
+    this.context = null;
+    this.toolNodes = {}; // lorsque la toolbar est dessinée , cet objet est garni
+                         // de raccourcis vers les éléments DOM correspondants aux outils.
+    this.base_url = '';
+    this.mode = 'wiki';
+    this.help_link = '';
+    this.shortcuts = {};
+    this.buttons = {}
+  }
+
+  getMode() {
+    return this.mode;
+  }
+
+  setMode(mode) {
+    this.mode = mode || 'wiki';
+  }
+
+  switchMode(mode) {
+    mode = mode || 'wiki';
+    this.draw(mode);
+  }
+
+  setHelpLink(link) {
+    this.help_link = link;
+  }
+
+  showHelp() {
+    window.open(this.help_link, '', 'resizable=yes, location=no, width=300, height=640, menubar=no, status=no, scrollbars=yes')
+  }
+
+  setPreviewUrl(url) {
+    this.previewTab.firstChild.setAttribute('data-url', url);
+  }
+
+  button(tool) {
+    if (typeof tool.fn[this.mode] != 'function') return null;
+
+    const className = 'jstb_' + tool.name;
+    let title = tool.title
+
+    if (tool.hasOwnProperty('shortcut')) {
+      this.shortcuts[tool.shortcut] = className;
+      title = this.buttonTitleWithShortcut(tool.title, tool.shortcut)
+    }
+
+    const b = new jsButton(title, tool.fn[this.mode], this, className, tool.name);
+    if (tool.icon != undefined) b.icon = tool.icon;
+
+    return b;
+  }
+
+  buttonTitleWithShortcut(title, shortcutKey) {
+    let i18nTitle
+    if(typeof jsToolBar.strings == 'undefined') {
+      i18nTitle = title || null;
+    } else {
+      i18nTitle = jsToolBar.strings[title.toLowerCase()] || title || null;
+    }
+
+    if (isMac()) {
+      return i18nTitle + " (⌘" + shortcutKey.toUpperCase() + ")";
+    } else {
+      return i18nTitle + " (Ctrl+" + shortcutKey.toUpperCase() + ")";
+    }
+  }
+
+  space(tool) {
+    const space = new jsSpace(tool.name)
+    if (tool.width !== undefined)
+      space.width = tool.width;
+    return space;
+  }
+
+  combo(toolName) {
+    const tool = this.formatter.elements[toolName];
+    const length = tool[this.mode].list.length;
+
+    if (typeof tool[this.mode].fn != 'function' || length == 0) {
+      return null;
+    } else {
+      const options = {};
+      for (let i=0; i < length; i++) {
+        const opt = tool[this.mode].list[i];
+        options[opt] = tool.options[opt];
+      }
+      return new jsCombo(tool.title, options, this, tool[this.mode].fn);
+    }
+  }
+
+  draw(mode) {
+    this.setMode(mode);
+
+    // Empty toolbar
+    while (this.toolbar.hasChildNodes()) {
+      this.toolbar.removeChild(this.toolbar.firstChild)
+    }
+    this.toolNodes = {}; // vide les raccourcis DOM/**/
+    this.buttons = {}
+
+    // Draw toolbar elements
+    let b, tool, newTool;
+
+    this.formatter.elements.forEach(b => {
+      const disabled =
+      b.type == undefined || b.type == ''
+      || (b.disabled != undefined && b.disabled)
+      || (b.context != undefined && b.context != null && b.context != this.context);
+
+      if (!disabled && typeof this[b.type] == 'function') {
+        tool = this[b.type](b);
+        if (tool) newTool = tool.draw();
+        if (newTool) {
+          this.toolNodes[b.name] = newTool; //mémorise l'accès DOM pour usage éventuel ultérieur
+          this.toolbar.appendChild(newTool);
+        }
+        if (b.type == 'button') {
+          this.buttons[b.name] = tool;
+        }
+      }
+    })
+  }
+
+  singleTag(stag,etag) {
+    stag = stag || null;
+    etag = etag || stag;
+
+    if (!stag || !etag) { return; }
+
+    this.encloseSelection(stag,etag);
+  }
+
+  encloseLineSelection(prefix, suffix, fn) {
+    this.textarea.focus();
+
+    prefix = prefix || '';
+    suffix = suffix || '';
+
+    let start, end, sel, scrollPos, subst, res;
+
+    if (typeof(document["selection"]) != "undefined") {
+      sel = document.selection.createRange().text;
+    } else if (typeof(this.textarea["setSelectionRange"]) != "undefined") {
+      start = this.textarea.selectionStart;
+      end = this.textarea.selectionEnd;
+      scrollPos = this.textarea.scrollTop;
+      // go to the start of the line
+      start = this.textarea.value.substring(0, start).replace(/[^\r\n]*$/g,'').length;
+      // go to the end of the line
+      end = this.textarea.value.length - this.textarea.value.substring(end, this.textarea.value.length).replace(/^[^\r\n]*/, '').length;
+      sel = this.textarea.value.substring(start, end);
+    }
+
+    if (sel.match(/ $/)) { // exclude ending space char, if any
+      sel = sel.substring(0, sel.length - 1);
+      suffix = suffix + " ";
+    }
+
+    if (typeof(fn) == 'function') {
+      res = (sel) ? fn.call(this,sel) : fn('');
+    } else {
+      res = (sel) ? sel : '';
+    }
+
+    subst = prefix + res + suffix;
+
+    if (typeof(document["selection"]) != "undefined") {
+      document.selection.createRange().text = subst;
+      const range = this.textarea.createTextRange();
+      range.collapse(false);
+      range.move('character', -suffix.length);
+      range.select();
+    } else if (typeof(this.textarea["setSelectionRange"]) != "undefined") {
+      this.textarea.value = this.textarea.value.substring(0, start) + subst +
+      this.textarea.value.substring(end);
+      if (sel || (!prefix && start === end)) {
+        this.textarea.setSelectionRange(start + subst.length, start + subst.length);
+      } else {
+        this.textarea.setSelectionRange(start + prefix.length, start + prefix.length);
+      }
+      this.textarea.scrollTop = scrollPos;
+    }
+  }
+
+  encloseSelection(prefix, suffix, fn) {
+    this.textarea.focus();
+    prefix = prefix || '';
+    suffix = suffix || '';
+
+    let start, end, sel, scrollPos, subst, res;
+
+    if (typeof(document["selection"]) != "undefined") {
+      sel = document.selection.createRange().text;
+    } else if (typeof(this.textarea["setSelectionRange"]) != "undefined") {
+      start = this.textarea.selectionStart;
+      end = this.textarea.selectionEnd;
+      scrollPos = this.textarea.scrollTop;
+      sel = this.textarea.value.substring(start, end);
+      if (start > 0 && this.textarea.value.substr(start-1, 1).match(/\S/)) {
+        prefix = ' ' + prefix;
+      }
+      if (this.textarea.value.substr(end, 1).match(/\S/)) {
+        suffix = suffix + ' ';
+      }
+    }
+    if (sel.match(/ $/)) { // exclude ending space char, if any
+      sel = sel.substring(0, sel.length - 1);
+      suffix = suffix + " ";
+    }
+
+    if (typeof(fn) == 'function') {
+      res = (sel) ? fn.call(this,sel) : fn('');
+    } else {
+      res = (sel) ? sel : '';
+    }
+
+    subst = prefix + res + suffix;
+
+    if (typeof(document["selection"]) != "undefined") {
+      document.selection.createRange().text = subst;
+      const range = this.textarea.createTextRange();
+      range.collapse(false);
+      range.move('character', -suffix.length);
+      range.select();
+    } else if (typeof(this.textarea["setSelectionRange"]) != "undefined") {
+      this.textarea.value = this.textarea.value.substring(0, start) + subst +
+      this.textarea.value.substring(end);
+      if (sel) {
+        this.textarea.setSelectionRange(start + subst.length, start + subst.length);
+      } else {
+        this.textarea.setSelectionRange(start + prefix.length, start + prefix.length);
+      }
+      this.textarea.scrollTop = scrollPos;
+    }
+  }
+
+  execute(event) {
+    const name = event.target.dataset.toolName;
+    const button = this.buttons[name];
+    if (typeof func !== undefined) {
+      button.execute()
+    }
+  }
+
+  showPreview(event) {
+    if (event.target.classList.contains('selected')) { return; }
+    jsToolBar.lastJstPreviewed = this.toolbarBlock;
+    this.preview.setAttribute('style', 'min-height: ' + this.textarea.clientHeight + 'px;')
+    this.toolbar.classList.add('hidden');
+    this.textarea.classList.add('hidden');
+    this.preview.classList.remove('hidden');
+    this.tabsBlock.querySelector('.tab-edit').classList.remove('selected');
+    event.target.classList.add('selected');
+  }
+
+  hidePreview(event) {
+    if (event.target.classList.contains('selected')) { return; }
+    this.toolbar.classList.remove('hidden');
+    this.textarea.classList.remove('hidden');
+    this.textarea.focus();
+    this.preview.classList.add('hidden');
+    this.tabsBlock.querySelector('.tab-preview').classList.remove('selected');
+    event.target.classList.add('selected');
+  }
+
+  keyboardShortcuts(e) {
+    let stop = false;
+    if (isToggleEditPreviewShortcut(e)) {
+      // Switch to preview only if Edit tab is selected when the event triggers.
+      if (this.tabsBlock.querySelector('.tab-edit.selected')) {
+        stop = true
+        this.tabsBlock.querySelector('.tab-preview').click();
+      }
+    }
+    if (isModifierKey(e) && this.shortcuts.hasOwnProperty(e.key.toLowerCase())) {
+      stop = true
+      this.toolbar.querySelector("." + this.shortcuts[e.key.toLowerCase()]).click();
+    }
+    if (stop) {
+      e.stopPropagation();
+      e.preventDefault();
+    }
+  }
+
+  stripBaseURL(url) {
+    if (this.base_url != '') {
+      const pos = url.indexOf(this.base_url);
+      if (pos == 0) {
+        url = url.substr(this.base_url.length);
+      }
+    }
+
+    return url;
+  }
+  /** Resizer
+  -------------------------------------------------------- */
+  resizeSetStartH() {
+    this.dragStartH = this.textarea.offsetHeight + 0;
+  }
+
+  resizeDragStart(event) {
+    this.dragStartY = event.clientY;
+    this.resizeSetStartH();
+    document.addEventListener('mousemove', this.dragMoveHdlr=(event) => {this.resizeDragMove(event);}, false);
+    document.addEventListener('mouseup', this.dragStopHdlr=(event) => {this.resizeDragStop(event);}, false);
+  }
+
+  resizeDragMove(event) {
+    this.textarea.style.height = (this.dragStartH+event.clientY-this.dragStartY)+'px';
+  }
+
+  resizeDragStop(event) {
+    document.removeEventListener('mousemove', this.dragMoveHdlr, false);
+    document.removeEventListener('mouseup', this.dragStopHdlr, false);
+  }
+
+  /* Code highlighting menu */
+  precodeMenu(fn){
+    this.createMenuElement('precode', 'code-highlighting-template', fn);
+    return false;
+  }
+
+  /* Table generator */
+  tableMenu(fn){
+    this.createMenuElement('table', 'table-generator-template', fn);
+    return false;
+  }
+
+  createMenuElement(name, templateId, fn) {
+    const template = document.getElementById(templateId);
+    const fragment = template.content.cloneNode(true);
+    const menu = document.body.appendChild(fragment.firstElementChild);
+
+    const rect = this.toolNodes[name].getBoundingClientRect();
+    menu.style.top  = `${rect.bottom + window.pageYOffset}px`;
+    menu.style.left = `${rect.left + window.pageXOffset}px`;
+    menu.addMenu = fn;
+
+    return menu;
+  }
+
+  togglePreview(e) {
+    if (isToggleEditPreviewShortcut(e)) {
+      if (jsToolBar.lastJstPreviewed !== null) {
+        e.preventDefault();
+        e.stopPropagation();
+        jsToolBar.lastJstPreviewed.querySelector('.tab-edit').click();
+        jsToolBar.lastJstPreviewed = null;
+      }
+    }
+  }
+
+  autofillListItem(e) {
+    if (e.inputType != 'insertLineBreak') return;
+
+    const target = e.currentTarget;
+    const { selectionStart, value } = target;
+
+    const beforeCursor = value.slice(0, selectionStart)
+    const lines = beforeCursor.split("\n")
+    const currentLine = lines[lines.length - 1]
+    const lineStartPos = beforeCursor.lastIndexOf("\n") + 1
+
+    const result = this.formatter.autofillListItem(currentLine)
+
+    if (!result) return
+
+    switch (result.action) {
+      case 'remove':
+        event.preventDefault()
+        target.setRangeText('', lineStartPos, selectionStart, 'start')
+        break
+      case 'insert':
+        event.preventDefault()
+        const insertText = "\n" + result.text
+        const newValue = value.slice(0, selectionStart) + insertText + value.slice(selectionStart)
+        const newCursor = selectionStart + insertText.length
+        target.value = newValue
+        target.setSelectionRange(newCursor, newCursor)
+        break
+      default:
+        return
+    }
+  }
+}
+
+function jsTabname(link, name) {
+  const tabName = jsToolBar.strings[name.toLowerCase()] || name || null;
+  if (typeof link !== 'undefined') {
+    link.innerText = tabName;
+  }
+}
+
+class jsButton {
+  constructor(title, fn, scope, className, name) {
+    if(typeof jsToolBar.strings == 'undefined') {
+      this.title = title || null;
+    } else {
+        this.title = jsToolBar.strings[name] || title || null;
+    }
+    this.fn = fn || function(){};
+    this.scope = scope || null;
+    this.className = className || null;
+    this.name = name
+  }
+
+  draw() {
+    if (!this.scope) return null;
+
+    const button = document.createElement('button');
+    button.setAttribute('type','button');
+    button.tabIndex = 200;
+    if (this.className) {
+      button.className = this.className;
+    }
+    button.title = this.title;
+    const span = document.createElement('span');
+    span.appendChild(document.createTextNode(this.title));
+    button.appendChild(span);
+    button.dataset.toolName = this.name;
+
+    if (this.icon != undefined) {
+      button.style.backgroundImage = `url(${this.icon})`;
+    }
+
+    return button;
+  }
+
+  execute() {
+    if (typeof(this.fn) == 'function') {
+      try {
+        this.fn.apply(this.scope, arguments)
+      } catch (e) {
+      }
+    }
+  }
+}
+
+class jsSpace {
+  constructor(className) {
+    this.className = className || null;
+    this.width = null;
+  }
+
+  draw() {
+    const span = document.createElement('span');
+    span.appendChild(document.createTextNode(String.fromCharCode(160)));
+    span.className = 'jstSpacer' + (this.className ? ' ' + this.className : '');
+    if (this.width) span.style.marginRight = this.width+'px';
+
+    return span;
+  }
+}
+
+class jsCombo {
+  constructor(title, options, scope, fn, className) {
+    this.title = title || null;
+    this.options = options || null;
+    this.scope = scope || null;
+    this.fn = fn || function(){};
+    this.className = className || null;
+  }
+
+  draw() {
+    if (!this.scope || !this.options) return null;
+
+    const select = document.createElement('select');
+    if (this.className) select.className = className;
+    select.title = this.title;
+
+    this.options.forEach(o => {
+      const option = document.createElement('option');
+      option.value = o;
+      option.appendChild(document.createTextNode(this.options[o]));
+      select.appendChild(option);
+    })
+
+    select.addEventListener('change', (e) =>  {
+      try {
+        this.fn.call(this.scope, e.currentTarget.value);
+      } catch (error) {
+        alert(error);
+      }
+
+      return false;
+    })
+
+    return select;
+  }
+}
+
+function isToggleEditPreviewShortcut(e) {
+  if ((e.metaKey || e.ctrlKey) && e.shiftKey && e.key.toLowerCase() === 'p') {
+    return true;
+  } else {
+    return false;
+  }
+}
+
+function isModifierKey(e) {
+  if (isMac() && e.metaKey) {
+    return true;
+  } else if (!isMac() && e.ctrlKey) {
+    return true;
+  } else {
+    return false;
+  }
+}
diff --git a/app/javascript/jstoolbar/formatting/common_mark.js b/app/javascript/jstoolbar/formatting/common_mark.js
new file mode 100644
index 000000000..edd177a04
--- /dev/null
+++ b/app/javascript/jstoolbar/formatting/common_mark.js
@@ -0,0 +1,276 @@
+/**
+ * This file is part of DotClear.
+ * Copyright (c) 2005 Nicolas Martin & Olivier Meunier and contributors. All rights reserved.
+ * This code is released under the GNU General Public License.
+ *
+ * Modified by JP LANG for common_mark formatting
+ */
+
+export default {
+  autofillListItem: (line) => {
+    // Match list items in CommonMark syntax.
+    // Captures either an ordered list (e.g., '1. ' or '2) ') or an unordered list (e.g., '* ', '- ', '+ ').
+    // The regex structure:
+    // ^(\s*)               → leading whitespace
+    // (?:(\d+)([.)])       → an ordered list marker: number followed by '.' or ')'
+    // |([*+\-])            → OR an unordered list marker: '*', '+', or '-'
+    // (.*)$                → the actual list item content
+    //
+    // Examples:
+    // '2. ordered text'           → indent='',  number='2', delimiter='.', bullet=undefined, content='ordered text'
+    // '  3) nested ordered text'  → indent='  ', number='3', delimiter=')', bullet=undefined, content='nested ordered text'
+    // '* unordered text'          → indent='', number=undefined, delimiter=undefined, bullet='*', content='unordered text'
+    // '+ unordered text'          → indent='', number=undefined, delimiter=undefined, bullet='+', content='unordered text'
+    // '  - nested unordered text' → indent='  ', number=undefined, delimiter=undefined, bullet='-', content='nested unordered text'
+    const match = line.match(/^(\s*)(?:(\d+)([.)])|([*+\-])) (.*)$/)
+    if (!match) return null
+
+    const indent = match[1]
+    const number = match[2]
+    const delimiter = match[3]
+    const bullet = match[4]
+    const content = match[5]
+
+    if (content === '') {
+      return { action: 'remove' }
+    }
+
+    if (number) {
+      const nextNumber = parseInt(number, 10) + 1
+      return { action: 'insert', text: `${indent}${nextNumber}${delimiter} ` }
+    } else {
+      return { action: 'insert', text: `${indent}${bullet} ` }
+    }
+  },
+
+  elements: [
+    {
+      name: 'strong',
+      type: 'button',
+      title: 'Strong',
+      shortcut: 'b',
+      fn: {
+        wiki: function() { this.singleTag('**') }
+      }
+    },
+    {
+      name: 'em',
+      type: 'button',
+      title: 'Italic',
+      shortcut: 'i',
+      fn: {
+        wiki: function() { this.singleTag("*") }
+      }
+    },
+    {
+      name: 'ins',
+      type: 'button',
+      title: 'Underline',
+      shortcut: 'u',
+      fn: {
+        wiki: function() { this.singleTag('<u>', '</u>') }
+      }
+    },
+    {
+      name: 'del',
+      type: 'button',
+      title: 'Deleted',
+      fn: {
+        wiki: function() { this.singleTag('~~') }
+      }
+    },
+    {
+      name: 'code',
+      type: 'button',
+      title: 'Code',
+      fn: {
+        wiki: function() { this.singleTag('`') }
+      }
+    },
+    {
+      name: 'space1',
+      type: 'space'
+    },
+    {
+      name: 'h1',
+      type: 'button',
+      title: 'Heading 1',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('# ', '',function(str) {
+            str = str.replace(/^#+\s+/, '')
+            return str;
+          });
+        }
+      }
+    },
+    {
+      name: 'h2',
+      type: 'button',
+      title: 'Heading 2',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('## ', '',function(str) {
+            str = str.replace(/^#+\s+/, '')
+            return str;
+          });
+        }
+      }
+    },
+    {
+      name: 'h3', 
+      type: 'button',
+      title: 'Heading 3',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('### ', '',function(str) {
+            str = str.replace(/^#+\s+/, '')
+            return str;
+          });
+        }
+      }
+    },
+    {
+      name: 'space2',
+      type: 'space'
+    },
+    {
+      name: 'ul',
+      type: 'button',
+      title: 'Unordered list',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)[#-]?\s*/g,"$1* ");
+          });
+        }
+      }
+    },
+    {
+      name: 'ol',
+      type: 'button',
+      title: 'Ordered list',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)[*-]?\s*/g,"$11. ");
+          });
+        }
+      }
+    },
+    {
+      name: 'tl',
+      type: 'button',
+      title: 'Task list',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)[*-]?\s*/g,"$1* [ ] ");
+          });
+        }
+      }
+    },
+    {
+      name: 'space3',
+      type: 'space'
+    },
+    {
+      name: 'bq',
+      type: 'button',
+      title: 'Quote',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)( *)([^\n]*)/g,"$1> $2$3");
+          });
+        }
+      }
+    },
+    {
+      name: 'unbq',
+      type: 'button',
+      title: 'Unquote',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^) *(> ?)?( *)([^\n]*)/g,"$1$3$4");
+          });
+        }
+      }
+    },
+    {
+      name: 'table',
+      type: 'button',
+      title: 'Table',
+      fn: {
+        wiki: function() {
+          this.tableMenu((cols, rowCount) => {
+            this.encloseLineSelection(
+              '|'+cols.join(' |')+' |\n' +                                   // header
+              Array(cols.length+1).join('|--')+'|\n' +                       // second line
+              Array(rowCount+1).join(Array(cols.length+1).join('|  ')+'|\n') // cells
+            );
+          });
+        }
+      }
+    },
+    {
+      name: 'pre',
+      type: 'button',
+      title: 'Preformatted text',
+      fn: {
+        wiki: function() { this.encloseLineSelection('```\n', '\n```') }
+      }
+    },
+    {
+      name: 'precode',
+      type: 'button',
+      title: 'Highlighted code',
+      fn: {
+        wiki: function() {
+          var This = this;
+          this.precodeMenu(function(lang){
+            This.encloseLineSelection('``` ' + lang + '\n', '\n```\n');
+          });
+        }
+      }
+    },
+    {
+      name: 'space4',
+      type: 'space'
+    },
+    {
+      name: 'link',
+      type: 'button',
+      title: 'Wiki link',
+      fn: {
+        wiki: function() { this.encloseSelection("[[", "]]") }
+      }
+    },
+    {
+      name: 'img',
+      type: 'button',
+      title: 'Image',
+      fn: {
+        wiki: function() { this.encloseSelection("![](", ")") }
+      }
+    },
+    {
+      name: 'space5',
+      type: 'space'
+    },
+    {
+      name: 'help',
+      type: 'button',
+      title: 'Help',
+      fn: {
+        wiki: function() { this.showHelp() }
+      }
+    }
+  ]
+}
diff --git a/app/javascript/jstoolbar/formatting/textile.js b/app/javascript/jstoolbar/formatting/textile.js
new file mode 100644
index 000000000..e4b6f9e39
--- /dev/null
+++ b/app/javascript/jstoolbar/formatting/textile.js
@@ -0,0 +1,236 @@
+/**
+ * This file is part of DotClear.
+ * Copyright (c) 2005 Nicolas Martin & Olivier Meunier and contributors. All rights reserved.
+ * This code is released under the GNU General Public License.
+ *
+ * Modified by JP LANG for markdown formatting
+ */
+
+export default {
+  autofillListItem: (line) => {
+    // Match list items in Textile syntax.
+    // Captures either an ordered list (using '#') or an unordered list (using '*').
+    // The regex structure:
+    // ^([*#]+)            → one or more list markers: '*' for unordered, '#' for ordered
+    // (.*)$               → the actual list item content
+    //
+    // Examples:
+    // '# ordered text'            → marker='#',  content='ordered text'
+    // '## nested ordered text'    → marker='##', content='nested ordered text'
+    // '* unordered text'          → marker='*',  content='unordered text'
+    // '** nested unordered text'  → marker='**', content='nested unordered text'
+    const match = line.match(/^([*#]+) (.*)$/)
+    if (!match) return null
+
+    const marker = match[1]
+    const content = match[2]
+
+    if (content === '') {
+      return { action: 'remove' }
+    }
+
+    return { action: 'insert', text: `${marker} ` }
+  },
+
+  elements: [
+    {
+      name: 'strong',
+      type: 'button',
+      title: 'Strong',
+      shortcut: 'b',
+      fn: {
+        wiki: function() { this.singleTag('*') }
+      }
+    },
+    {
+      name: 'em',
+      type: 'button',
+      title: 'Italic',
+      shortcut: 'i',
+      fn: {
+        wiki: function() { this.singleTag("_") }
+      }
+    },
+    {
+      name: 'ins',
+      type: 'button',
+      title: 'Underline',
+      shortcut: 'u',
+      fn: {
+        wiki: function() { this.singleTag('+') }
+      }
+    },
+    {
+      name: 'del',
+      type: 'button',
+      title: 'Deleted',
+      fn: {
+        wiki: function() { this.singleTag('-') }
+      }
+    },
+    {
+      name: 'code',
+      type: 'button',
+      title: 'Code',
+      fn: {
+        wiki: function() { this.singleTag('@') }
+      }
+    },
+    { name: 'space1', type: 'space'},
+    {
+      name: 'h1',
+      type: 'button',
+      title: 'Heading 1',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('h1. ', '',function(str) {
+            str = str.replace(/^h\d+\.\s+/, '')
+            return str;
+          });
+        }
+      }
+    },
+    {
+      name: 'h2',
+      type: 'button',
+      title: 'Heading 2',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('h2. ', '',function(str) {
+            str = str.replace(/^h\d+\.\s+/, '')
+            return str;
+          });
+        }
+      }
+    },
+    {
+      name: 'h3',
+      type: 'button',
+      title: 'Heading 3',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('h3. ', '',function(str) {
+            str = str.replace(/^h\d+\.\s+/, '')
+            return str;
+          });
+        }
+      }
+    },
+    { name: 'space2', type: 'space'},
+    {
+      name: 'ul',
+      type: 'button',
+      title: 'Unordered list',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)[#-]?\s*/g,"$1* ");
+          });
+        }
+      }
+    },
+    {
+      name: 'ol',
+      type: 'button',
+      title: 'Ordered list',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)[*-]?\s*/g,"$1# ");
+          });
+        }
+      }
+    },
+    { name: 'space3', type: 'space'},
+    {
+      name: 'bq',
+      type: 'button',
+      title: 'Quote',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^)( *)([^\n]*)/g,"$1> $2$3");
+          });
+        }
+      }
+    },
+    {
+      name: 'unbq',
+      type: 'button',
+      title: 'Unquote',
+      fn: {
+        wiki: function() {
+          this.encloseLineSelection('','',function(str) {
+            str = str.replace(/\r/g,'');
+            return str.replace(/(\n|^) *(> ?)?( *)([^\n]*)/g,"$1$3$4");
+          });
+        }
+      }
+    },
+    {
+      name: 'table',
+      type: 'button',
+      title: 'Table',
+      fn: {
+        wiki: function() {
+          this.tableMenu((cols, rowCount) => {
+            this.encloseLineSelection(
+              '|_.'+cols.join('|_.')+'|\n' +                                 // header
+              Array(rowCount+1).join(Array(cols.length+1).join('|  ')+'|\n') // cells
+            );
+          });
+        }
+      }
+    },
+    {
+      name: 'pre',
+      type: 'button',
+      title: 'Preformatted text',
+      fn: {
+        wiki: function() { this.encloseLineSelection('<pre>\n', '\n</pre>') }
+      }
+    },
+    {
+      name: 'precode',
+      type: 'button',
+      title: 'Highlighted code',
+      fn: {
+        wiki: function() {
+          var This = this;
+          this.precodeMenu(function(lang){
+            This.encloseLineSelection('<pre><code class="' + lang + '">\n', '\n</code></pre>\n');
+          });
+        }
+      }
+    },
+    { name: 'space4', type: 'space'},
+    {
+      name: 'link',
+      type: 'button',
+      title: 'Wiki link',
+      fn: {
+        wiki: function() { this.encloseSelection("[[", "]]") }
+      }
+    },
+    {
+      name: 'img',
+      type: 'button',
+      title: 'Image',
+      fn: {
+        wiki: function() { this.encloseSelection("!", "!") }
+      }
+    },
+    { name: 'space5', type: 'space'},
+    {
+      name: 'help',
+      type: 'button',
+      title: 'Help',
+      fn: {
+        wiki: function() { this.showHelp() }
+      }
+    }
+  ]
+}
diff --git a/app/views/common/_code_highlighting.html.erb b/app/views/common/_code_highlighting.html.erb
new file mode 100644
index 000000000..c5aa8bb70
--- /dev/null
+++ b/app/views/common/_code_highlighting.html.erb
@@ -0,0 +1,12 @@
+<template id="code-highlighting-template">
+  <ul class="jst_menu"
+      style="position: absolute;width: 150px"
+      data-controller="precode"
+      data-action="pointerover->precode#select pointerout->precode#unselect pointerdown->precode#addMenu pointerdown->precode#remove click@window->precode#removeWhenOutside">
+    <% langs.each do |lang| %>
+      <li class="jst_menuitem">
+        <div class="jst_menuitem-wrapper"><%= lang %></div>
+      </li>
+     <% end %>
+  <ul>
+</template>
